Index: Vagrantfile
===================================================================
--- Vagrantfile	(revision 072b52cd18b9b25ae7d9b369e6b613da2b7aff70)
+++ Vagrantfile	(revision 601b93d4f5d0df9b804d41b2f5cd81359a7dd583)
@@ -21,6 +21,5 @@
   # Every Vagrant development environment requires a box. You can search for
   # boxes at https://atlas.hashicorp.com/search.
-  config.vm.box = "ubuntu1404"
-  config.vm.box_url = "https://github.com/hnakamur/packer-templates/releases/download/v1.0.2/ubuntu-14-04-x64-virtualbox.box"
+  config.vm.box = "ubuntu/trusty64"
   #config.vm.box = "fedora19"
   #config.vm.box_url = "https://dl.dropboxusercontent.com/u/86066173/fedora-19.box"
Index: build_tools/sasview_deploy_test.au3
===================================================================
--- build_tools/sasview_deploy_test.au3	(revision 55bbe0b27a20e96052e70b3b233bcf5dff44cea3)
+++ build_tools/sasview_deploy_test.au3	(revision e9f8208976730e8b55d9cbc48c4d9bfc30db61ec)
@@ -92,8 +92,9 @@
    ; Start app - DEBUG ONLY
    ;;Run("C:\Program Files (x86)\SasView\SasView.exe")
+   local $sActiveWindow = "SasView  - Fitting -"
    Local $iFailFlag = 2
    ; Wait for the window
    Sleep(1000)
-   Local $hWnd = WinWaitActive("SasView  - Fitting -", "", $lTimeout)
+   Local $hWnd = WinWaitActive($sActiveWindow, "", $lTimeout)
    Assert($hWnd, $iFailFlag)
 
@@ -113,9 +114,27 @@
    ControlClick($hWnd, "Send To", 231)
 
-   ;; Choose a model
+   ;; Choose a python model
    ControlCommand($hWnd, "", "ComboBox3", "SetCurrentSelection", 1)
-
    ;; Calculate the model
    ControlClick($hWnd, "Compute", 211)
+   ;; Assure we got the charts
+   Local $hPlot = WinWait($sActiveWindow, "Graph2", $lTimeout)
+   Assert($hPlot, $iFailFlag)
+   $hPlot = WinWait($sActiveWindow, "Graph3", $lTimeout)
+   Assert($hPlot, $iFailFlag)
+
+   sleep(1000)
+   ;; Calculate a compiled model
+   ControlClick($hWnd, "Send To", 231)
+
+   ;; Choose Shapes/Cylinder
+   ControlCommand($hWnd, "", "ComboBox2", "SetCurrentSelection", 1)
+   ControlCommand($hWnd, "", "ComboBox3", "SetCurrentSelection", 11)
+   ;; Calculate the model
+   ControlClick($hWnd, "Compute", 211)
+
+   ;; Assure we got another chart
+   $hPlot = WinWait($sActiveWindow, "Graph4", $lTimeout)
+   Assert($hPlot, $iFailFlag)
 
    ;; Close SasView
Index: build_tools/travis_build.sh
===================================================================
--- build_tools/travis_build.sh	(revision 68e6ac8dfb8e0ac6022e1d579d09bf5e755c908e)
+++ build_tools/travis_build.sh	(revision 68e6ac8dfb8e0ac6022e1d579d09bf5e755c908e)
@@ -0,0 +1,48 @@
+# Simplified build for Travic CI
+# No documentation is built
+export PATH=$PATH:/usr/local/bin/
+
+PYTHON=${PYTHON:-`which python`}
+EASY_INSTALL=${EASY_INSTALL:-`which easy_install`}
+
+export PYTHONPATH=$PYTHONPATH:$WORKSPACE/sasview/utils
+export PYTHONPATH=$PYTHONPATH:$WORKSPACE/sasview/sasview-install
+
+# SET SASVIEW GITHASH
+cd $WORKSPACE/sasview/sasview
+githash=$( git rev-parse HEAD )
+sed -i.bak s/GIT_COMMIT/$githash/g __init__.py
+
+# SASMODELS
+cd $WORKSPACE/sasmodels
+rm -rf build
+rm -rf dist
+$PYTHON setup.py clean
+$PYTHON setup.py build
+$PYTHON setup.py bdist_egg
+
+# SASVIEW
+cd $WORKSPACE/sasview
+rm -rf sasview-install
+mkdir  sasview-install
+rm -rf utils
+mkdir  utils
+rm -rf dist
+rm -rf build
+
+# INSTALL SASMODELS
+cd $WORKSPACE/sasmodels/dist
+$EASY_INSTALL -d $WORKSPACE/sasview/utils sasmodels*.egg
+
+# BUILD SASVIEW
+cd $WORKSPACE/sasview
+$PYTHON setup.py clean
+$PYTHON setup.py build docs bdist_egg
+
+# INSTALL SASVIEW
+cd $WORKSPACE/sasview/dist
+$EASY_INSTALL -d $WORKSPACE/sasview/sasview-install sasview*.egg
+
+# TEST
+cd $WORKSPACE/sasview/test
+$PYTHON utest_sasview.py
Index: sasview/__init__.py
===================================================================
--- sasview/__init__.py	(revision 801a2968ae0b500c87588ecf8a8bd3c52546b4ee)
+++ sasview/__init__.py	(revision 9a182b24778d8ca30e8e54968548156199dd1240)
@@ -1,14 +1,18 @@
-__version__ = "4.0.0-alpha"
+__version__ = "4.0"
 __build__ = "GIT_COMMIT"
 try:
+    import logging
     import subprocess
     import os
+    import platform
     FNULL = open(os.devnull, 'w')
-    git_revision = subprocess.check_output(['git', 'rev-parse', 'HEAD'],
+    if platform.system() == "Windows":
+        args = ['git', 'describe', '--tags']
+    else:
+        args = ['git describe --tags']
+    git_revision = subprocess.check_output(args,
                     stderr=FNULL,
                     shell=True)
     __build__ = str(git_revision).strip()
-except:
-    import logging
-    import sys
-    logging.warning("Error while determining build number\n  %s" % sys.exc_value)
+except subprocess.CalledProcessError as cpe:
+    logging.warning("Error while determining build number\n  Using command:\n %s \n Output:\n %s"% (cpe.cmd,cpe.output))
Index: sasview/installer_generator.py
===================================================================
--- sasview/installer_generator.py	(revision 09afe905cc9186fc6fe30cdfb86e1fd68ebe2949)
+++ sasview/installer_generator.py	(revision 525aaa231efcdef4de8d468033aeb8e7b49dad96)
@@ -199,4 +199,6 @@
     msg += """Source: "dist\plugin_models\*";\tDestDir: "{userdesktop}\..\.sasview\plugin_models";\t"""
     msg += """Flags: recursesubdirs createallsubdirs\n""" 
+    msg += """Source: "dist\compiled_models\*";\tDestDir: "{userdesktop}\..\.sasmodels\compiled_models";\t"""
+    msg += """Flags: recursesubdirs createallsubdirs\n"""
     msg += """Source: "dist\config\custom_config.py";\tDestDir: "{userdesktop}\..\.sasview\config";\t""" 
     msg += """Flags: recursesubdirs createallsubdirs\n"""
Index: sasview/local_config.py
===================================================================
--- sasview/local_config.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ sasview/local_config.py	(revision c1fdf8485e681ba1145937521615515e6c3be688)
@@ -31,23 +31,24 @@
 _acknowledgement_preamble =\
 '''To ensure the long term support and development of this software please''' +\
-''' remember to do the following.'''
+''' remember to:'''
 _acknowledgement_preamble_bullet1 =\
-'''Acknowledge its use in your publications as suggested below'''
+'''Acknowledge its use in your publications as suggested below;'''
 _acknowledgement_preamble_bullet2 =\
-'''Reference the following website: http://www.sasview.org'''
+'''Reference SasView as : M. Doucet, et al. SasView Version 4.0, Zenodo''' +\
+''', http://doi.org/10.5281/zenodo.159083;'''
 _acknowledgement_preamble_bullet3 =\
-'''Reference the model you used if appropriate (see documentation for refs)'''
+'''Reference the model you used if appropriate (see documentation for refs);'''
 _acknowledgement_preamble_bullet4 =\
 '''Send us your reference for our records: developers@sasview.org'''
 _acknowledgement_publications = \
-'''This work benefited from the use of the SasView application, originally
-developed under NSF award DMR-0520547.
-'''
+'''This work benefited from the use of the SasView application, originally developed under NSF Award 
+DMR-0520547. SasView also contains code developed with funding from the EU Horizon 2020 research 
+and innovation programme under the SINE2020 project Grant No 654000.'''
+
 _acknowledgement =  \
-'''This work originally developed as part of the DANSE project funded by the NSF
-under grant DMR-0520547, and currently maintained by NIST, UMD, ORNL, ISIS, ESS
-and ILL.
+'''This work was originally developed as part of the DANSE project funded by the US NSF under Award DMR-0520547, but is currently maintained by a 
+collaboration between UTK, UMD, NIST, ORNL, ISIS, ESS, ILL and ANSTO. SasView also contains code developed with funding from the EU Horizon 2020 
+research and innovation programme under the SINE2020 project (Grant No 654000).'''
 
-'''
 _homepage = "http://www.sasview.org"
 _download = __download_page__
@@ -65,7 +66,9 @@
 _umd_logo = os.path.join(icon_path, "umd_logo.png")
 _sns_logo = os.path.join(icon_path, "sns_logo.png")
+_ornl_logo = os.path.join(icon_path, "ornl_logo.png")
 _isis_logo = os.path.join(icon_path, "isis_logo.png")
 _ess_logo = os.path.join(icon_path, "ess_logo.png")
 _ill_logo = os.path.join(icon_path, "ill_logo.png")
+_ansto_logo = os.path.join(icon_path, "ansto_logo.png")
 _nsf_logo = os.path.join(icon_path, "nsf_logo.png")
 _danse_logo = os.path.join(icon_path, "danse_logo.png")
@@ -74,13 +77,15 @@
 _umd_url = "http://www.umd.edu/"
 _sns_url = "http://neutrons.ornl.gov/"
+_ornl_url = "http://neutrons.ornl.gov/"
 _nsf_url = "http://www.nsf.gov"
 _isis_url = "http://www.isis.stfc.ac.uk/"
 _ess_url = "http://ess-scandinavia.eu/"
 _ill_url = "http://www.ill.eu/"
+_ansto_url = "http://www.ansto.gov.au/"
 _danse_url = "http://www.cacr.caltech.edu/projects/danse/release/index.html"
 _inst_url = "http://www.utk.edu"
 _corner_image = os.path.join(icon_path, "angles_flat.png")
 _welcome_image = os.path.join(icon_path, "SVwelcome.png")
-_copyright = "(c) 2009 - 2013, UTK, UMD, NIST, ORNL, ISIS, ESS and ILL"
+_copyright = "(c) 2009 - 2016, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL and ANSTO"
 
 
Index: sasview/setup_exe.py
===================================================================
--- sasview/setup_exe.py	(revision 09afe905cc9186fc6fe30cdfb86e1fd68ebe2949)
+++ sasview/setup_exe.py	(revision 9bbc0746d460d36edd233363e4474810ed181b3a)
@@ -165,5 +165,5 @@
         self.version = local_config.__version__
         self.company_name = "SasView.org"
-        self.copyright = "copyright 2009 - 2013"
+        self.copyright = "copyright 2009 - 2016"
         self.name = "SasView"
         
@@ -208,4 +208,14 @@
 import sas.sasgui.guiframe as guiframe
 data_files += guiframe.data_files()
+
+# precompile sas models into the sasview build path; doesn't matter too much
+# where it is so long as it is a place that will get cleaned up afterwards.
+import sasmodels.core
+dll_path = os.path.join(build_path, 'compiled_models')
+compiled_dlls = sasmodels.core.precompile_dlls(dll_path, dtype='double')
+
+# include the compiled models as data; coordinate the target path for the
+# data with installer_generator.py
+data_files.append(('compiled_models', compiled_dlls))
 
 import sasmodels
Index: src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py	(revision 80c5d4645fc45af0c2a06ead98749184616799ef)
+++ src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py	(revision a235f71571822c52f74fd1221fcd542805cf1277)
@@ -45,5 +45,5 @@
     output = None
 
-    def __init__(self):
+    def reset_state(self):
         self.current_dataset = Data1D(np.empty(0), np.empty(0),
                                             np.empty(0), np.empty(0))
@@ -72,5 +72,5 @@
 
         ## Reinitialize the class when loading a new data file to reset all class variables
-        self.__init__()
+        self.reset_state()
         ## Check that the file exists
         if os.path.isfile(filename):
@@ -84,7 +84,4 @@
                 self.raw_data = buff.splitlines()
                 self.read_data()
-                xml_intermediate = self.raw_data[self.upper:]
-                xml = ''.join(xml_intermediate)
-                self.set_xml_file(xml)
         return self.output
 
@@ -100,19 +97,82 @@
         self.lower = 5
         self.upper = self.lower + self.data_points
-        self.detector.distance = float(line4[1])
+        self.source.radiation = 'x-ray'
+        normal = float(line4[3])
         self.current_dataset.source.radiation = "x-ray"
         self.current_dataset.source.name = "Anton Paar SAXSess Instrument"
         self.current_dataset.source.wavelength = float(line4[4])
-        normal = line4[3]
+        xvals = []
+        yvals = []
+        dyvals = []
         for i in range(self.lower, self.upper):
+            index = i - self.lower
             data = self.raw_data[i].split()
-            x_val = [float(data[0])]
-            y_val = [float(data[1])]
-            dy_val = [float(data[2])]
-            self.current_dataset.x = np.append(self.current_dataset.x, x_val)
-            self.current_dataset.y = np.append(self.current_dataset.y, y_val)
-            self.current_dataset.dy = np.append(self.current_dataset.dy, dy_val)
-        self.current_dataset.xaxis("Q (%s)" % (q_unit), q_unit)
-        self.current_dataset.yaxis("Intensity (%s)" % (i_unit), i_unit)
-        self.current_dataset.detector.append(self.detector)
+            xvals.insert(index, normal * float(data[0]))
+            yvals.insert(index, normal * float(data[1]))
+            dyvals.insert(index, normal * float(data[2]))
+        self.current_dataset.x = np.append(self.current_dataset.x, xvals)
+        self.current_dataset.y = np.append(self.current_dataset.y, yvals)
+        self.current_dataset.dy = np.append(self.current_dataset.dy, dyvals)
+        if self.data_points != self.current_dataset.x.size:
+            self.errors.add("Not all data was loaded properly.")
+        if self.current_dataset.dx.size != self.current_dataset.x.size:
+            dxvals = np.zeros(self.current_dataset.x.size)
+            self.current_dataset.dx = dxvals
+        if self.current_dataset.x.size != self.current_dataset.y.size:
+            self.errors.add("The x and y data sets are not the same size.")
+        if self.current_dataset.y.size != self.current_dataset.dy.size:
+            self.errors.add("The y and dy datasets are not the same size.")
+        self.current_dataset.errors = self.errors
+        self.current_dataset.xaxis("Q", q_unit)
+        self.current_dataset.yaxis("Intensity", i_unit)
+        xml_intermediate = self.raw_data[self.upper:]
+        xml = ''.join(xml_intermediate)
+        self.set_xml_string(xml)
+        dom = self.xmlroot.xpath('/fileinfo')
+        self._parse_child(dom)
         self.output.append(self.current_dataset)
+
+    def _parse_child(self, dom, parent=''):
+        """
+        Recursive method for stepping through the embedded XML
+        :param dom: XML node with or without children
+        """
+        for node in dom:
+            tagname = node.tag
+            value = node.text
+            attr = node.attrib
+            key = attr.get("key", '')
+            if len(node.getchildren()) > 1:
+                self._parse_child(node, key)
+                if key == "SampleDetector":
+                    self.current_dataset.detector.append(self.detector)
+                    self.detector = Detector()
+            else:
+                if key == "value":
+                    if parent == "Wavelength":
+                        self.current_dataset.source.wavelength = value
+                    elif parent == "SampleDetector":
+                        self.detector.distance = value
+                    elif parent == "Temperature":
+                        self.current_dataset.sample.temperature = value
+                    elif parent == "CounterSlitLength":
+                        self.detector.slit_length = value
+                elif key == "unit":
+                    value = value.replace("_", "")
+                    if parent == "Wavelength":
+                        self.current_dataset.source.wavelength_unit = value
+                    elif parent == "SampleDetector":
+                        self.detector.distance_unit = value
+                    elif parent == "X":
+                        self.current_dataset.xaxis(self.current_dataset._xaxis, value)
+                    elif parent == "Y":
+                        self.current_dataset.yaxis(self.current_dataset._yaxis, value)
+                    elif parent == "Temperature":
+                        self.current_dataset.sample.temperature_unit = value
+                    elif parent == "CounterSlitLength":
+                        self.detector.slit_length_unit = value
+                elif key == "quantity":
+                    if parent == "X":
+                        self.current_dataset.xaxis(value, self.current_dataset._xunit)
+                    elif parent == "Y":
+                        self.current_dataset.yaxis(value, self.current_dataset._yunit)
